<template>
  <a
    v-if="enlargable && displayedAvatarLarge"
    :class="classes"
    :href="displayedAvatarLarge"
    :data-fancybox="groupName"
    :data-caption="caption"
    data-bs-toggle="tooltip"
    :title="tooltip"
  >
    <img :src="displayedAvatarThumb" :alt="caption" :title="caption" />
  </a>
  <div
    v-else
    :class="classes"
    :style="{ 'background-image': `url(${displayedAvatarThumb})` }"
    data-bs-toggle="tooltip"
    :title="tooltip"
  />
</template>

<script>
import { computed, onMounted } from 'vue'
import { Fancybox } from '@fancyapps/ui'
import { useApi } from '../../core'
import ImageHelper from '../lib/image-helper.js'

export default {
  name: 'UserAvatar',
  props: {
    user: { type: Object, required: true },
    size: { type: String, default: '' },
    enlargable: { type: Boolean, default: false },
  },
  setup(props) {
    const api = useApi()

    const classes = computed(() => {
      return props.size ? ['user-avatar', `user-avatar--${props.size}`] : ['user-avatar']
    })

    const displayedAvatarThumb = computed(() => {
      const url =
        props.user && props.user.nestedResources.image
          ? ImageHelper.getImageUrl(api.storageBaseUrl, props.user.nestedResources.image, 'thumb')
          : ''

      return url.length > 0 ? url : '/images/layout/no-avatar.png'
    })

    const displayedAvatarLarge = computed(() => {
      return props.user && props.user.nestedResources.image
        ? ImageHelper.getImageUrl(api.storageBaseUrl, props.user.nestedResources.image, 'large')
        : ''
    })

    const tooltip = computed(() => {
      return props.user ? props.user.username : ''
    })

    const groupName = computed(() => {
      return props.user.username + '__avatar'
    })

    const caption = computed(() => {
      return props.user && props.user.image ? props.user.nestedResources.image.caption : ''
    })

    onMounted(() => {
      Fancybox.bind('[data-fancybox]', {
        Hash: false,
      })
    })

    return {
      classes,
      displayedAvatarThumb,
      displayedAvatarLarge,
      tooltip,
      groupName,
      caption,
    }
  },
}
</script>

<style lang="scss">
.user-avatar {
  display: inline-block;
  width: 128px;
  height: 128px;
  background-size: cover;
  background-position: center center;
  border-radius: 50%; // Circle
  border: 1px rgba(128, 128, 128, 0.125) solid;
}

.user-avatar img {
  width: inherit;
  height: inherit;
  border-radius: inherit;
  border-radius: inherit;
}

.user-avatar--xs {
  width: 16px;
  height: 16px;
}

.user-avatar--sm {
  width: 32px;
  height: 32px;
}

.user-avatar--md {
  width: 64px;
  height: 64px;
}

.user-avatar--lg {
  // Default
  width: 128px;
  height: 128px;
}

.user-avatar--xl {
  width: 256px;
  height: 256px;
}
</style>
